@ECHO OFF
:: COMNTEST.BAT - tests speed of different methods for
:: embedding comments in batch files
IF NOT '%1'=='' GOTO OneTest
CLS
ECHO This batch file will reset your system time.
ECHO Press Ctrl-Break to abort, any other key to continue.
ECHO =====================================================
PAUSE > NUL
CLS
ECHO Creating test files...

::Create $SHORT1$.BAT
ECHO @ECHO OFF > $SHORT1$.BAT
ECHO GOTO Start >> $SHORT1$.BAT
COPY $SHORT1$.BAT $LONG_1$.BAT > NUL
ECHO :Start >> $SHORT1$.BAT

::Create $LONG_?$.BAT files
COPY $LONG_1$.BAT $LONG_3$.BAT > NUL
ECHO REM   Text Text Text Text Text Text Text Text Text> TMP1$.DAT
SET return=Return1
GOTO BuildTemp
:===== Return1 ======
SET return=
COPY $LONG_1$.BAT + TMP1$.DAT > NUL
COPY $LONG_1$.BAT + TMP1$.DAT $LONG_2$.BAT > NUL
ECHO :Start >> $LONG_1$.BAT
ECHO :Start >> $LONG_2$.BAT
ECHO REM   Text Text Text Text Text Text Text Text Text  Text Text Text Text Text Text Text Text Text Tex> TMP1$.DAT
SET return=Return1a
GOTO BuildTemp
:===== Return1a =====
SET return=
COPY $LONG_3$.BAT + TMP1$.DAT > NUL
ECHO :Start >> $LONG_3$.BAT

::Create $REMS_?$.BAT files
TYPE $LONG_1$.BAT | FIND /V "Start" > $REMS_1$.BAT
TYPE $LONG_2$.BAT | FIND /V "Start" > $REMS_2$.BAT
TYPE $LONG_3$.BAT | FIND /V "Start" > $REMS_3$.BAT

::Create $COLON?$.BAT files
ECHO @ECHO OFF > $COLON1$.BAT
ECHO ::    Text Text Text Text Text Text Text Text Text> TMP1$.DAT
SET return=Return2
GOTO BuildTemp
:===== Return2 ======
SET return=
COPY $COLON1$.BAT + TMP1$.DAT > NUL
COPY $COLON1$.BAT + TMP1$.DAT $COLON2$.BAT > NUL
DEL TMP1$.DAT

ECHO @ECHO OFF > $COLON3$.BAT
ECHO ::    Text Text Text Text Text Text Text Text Text  Text Text Text Text Text Text Text Text Text Tex> TMP1$.DAT
SET return=Return2a
GOTO BuildTemp
:===== Return2a =====
SET return=
COPY $COLON3$.BAT + TMP1$.DAT > NUL
DEL TMP1$.DAT

::Create $EMPTY1$.BAT
REM > $EMPTY1$.BAT

::Create CURRENT.BAT
ECHO @ECHO OFF > CURRENT.BAT
ECHO SET ctime=%%3>> CURRENT.BAT
ECHO FOR %%%%v IN (/%%ctime%%) DO SET ctime=%%%%v>> CURRENT.BAT
ECHO FOR %%%%v IN (/%%ctime%%) DO SET ctime=%%%%v>> CURRENT.BAT
ECHO FOR %%%%v IN (/%%ctime%%) DO SET ctime=%%%%v>> CURRENT.BAT
ECHO FOR %%%%v IN (/%%ctime%%) DO SET ctime=%%%%v>> CURRENT.BAT
ECHO FOR %%%%v IN (/%%ctime%%) DO SET ctime=%%%%v>> CURRENT.BAT
ECHO FOR %%%%v IN (/%%ctime%%) DO SET ctime=%%%%v>> CURRENT.BAT

ECHO Tests beginning...
ECHO.
FOR %%v IN (EMPTY SHORT LONG_ REMS_ COLON) DO CALL %0 $%%v1$.BAT %%v
ECHO.
ECHO ===== Now with twice as many lines =====
ECHO.
FOR %%v IN (LONG_ REMS_ COLON) DO CALL %0 $%%v2$.BAT %%v
ECHO.
ECHO ===== Now with lines twice as long =====
ECHO.
FOR %%v IN (LONG_ REMS_ COLON) DO CALL %0 $%%v3$.BAT %%v
ECHO.
FOR %%v IN (1 2 3) DO DEL $?????%%v$.BAT
SET ctime=
DEL CHEKTIME.BAT
DEL CURRENT.BAT
ECHO.
ECHO Remember to correct the system time!
GOTO End

:===== BuildTemp (subroutine)
:: If the REMS test takes over a minute on your machine,
:: delete the next two lines.
COPY TMP1$.DAT+TMP1$.DAT TMP2$.DAT > NUL
COPY TMP2$.DAT+TMP2$.DAT TMP1$.DAT > NUL
COPY TMP1$.DAT+TMP1$.DAT TMP2$.DAT > NUL
COPY TMP2$.DAT+TMP2$.DAT TMP1$.DAT > NUL
COPY TMP1$.DAT+TMP1$.DAT TMP2$.DAT > NUL
COPY TMP2$.DAT+TMP2$.DAT TMP1$.DAT > NUL
COPY TMP1$.DAT+TMP1$.DAT TMP2$.DAT > NUL
COPY TMP2$.DAT+TMP2$.DAT TMP1$.DAT > NUL
DEL TMP2$.DAT
GOTO %Return%

:===== OneTest ======
TIME 0
FOR %%v IN (x x x x x x x x x x x x x x x x x x x x x x x x x) DO CALL %1
ECHO.| TIME > CHEKTIME.BAT
CALL CHEKTIME.BAT
ECHO %2 batch file took %ctime% seconds.
:===== End ==========
